{ config, lib, pkgs, ... }:

{
  # ZFS automatic snapshots
  services.zfs.autoSnapshot = {
    enable = true;
    frequent = 0;
    hourly = 24;
    daily = 7;
    weekly = 4;
    monthly = 12;
  };

  # Syncthing configuration
  services.syncthing = {
    enable = true;
    user = "coolneng";
    dataDir = "/home/coolneng";
    declarative = {
      devices = {
        zion = {
          id =
            "CCE5E4W-REWN7PZ-4JQEE2P-BF3XVV5-LJA7K6P-RDXQH65-EA7UBW6-J4E2GQ4";
          addresses = [ "tcp://10.8.0.1:22000" ];
        };
      };
      folders = {
        Documents = {
          id = "wusdj-bfjkr";
          path = "/home/coolneng/Documents";
          devices = [ "zion" ];
          versioning = {
            type = "simple";
            params = { keep = "5"; };
          };
        };

        Notes = {
          id = "kafhz-bfmzm";
          path = "/home/coolneng/Notes";
          devices = [ "zion" ];
          versioning = {
            type = "simple";
            params = { keep = "5"; };
          };
        };

        Music = {
          id = "2aqt7-vpprc";
          path = "/home/coolneng/Music";
          devices = [ "zion" ];
        };

        Photos = {
          id = "mjibc-ustcg";
          path = "/home/coolneng/Photos";
          devices = [ "zion" ];
        };

        Projects = {
          id = "cjhmu-avy9v";
          path = "/home/coolneng/Projects";
          devices = [ "zion" ];
        };

        Phone = {
          id = "m2007j20cg_288y-photos";
          type = "receiveonly";
          path = "/home/coolneng/Photos/Phone";
          devices = [ "zion" ];
        };

        Files = {
          id = "tsk52-u6rbk";
          path = "/home/coolneng/Files";
          devices = [ "zion" ];
        };
      };
    };
  };
}
